(function () {
    "use strict";

    angular.module('core').controller('vendedorDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', '$q', '$alert', 'contatoService', 'lookupService'];

    function controller($scope, $timeout, $state, $stateParams, $q, $alert, contatoService, lookupService) {
        $scope.initializeLayout('Vendedor');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false
        };
        $scope.popups = {
            empresa: {
                ativo: false
            },
            senha: {
                nova: null,
                exibir: false,
                salvando: false,
                ativo: false,
                toggle: function () {
                    $scope.popups.senha.ativo = !$scope.popups.senha.ativo;
                    $scope.popups.senha.nova = null;
                },
                save: function () {
                    $scope.popups.senha.salvando = true;
                    contatoService
                        .setSenhaVendedor({ id: $scope.state.item.ID, senha: $scope.popups.senha.nova })
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.state.item = response.Data;
                                    $scope.popups.senha.toggle();

                                    $scope.tools.toastr.success('A senha foi alterada com sucesso.');
                                }
                                $scope.popups.senha.salvando = false;
                            },
                            function (_error) {
                                $scope.popups.senha.salvando = false;
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                }
            }
        };

        $scope.auxiliar = {
            loja: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllLoja({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else {
                                    return response.Data;
                                }

                            })
                    );
                },
            },
            estado: {
                data: [],
                args: {},
                getAll: function () {
                    lookupService
                        .getAllEstado($scope.auxiliar.estado.args)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    angular.copy(angular.fromJson(response.Data), $scope.auxiliar.estado.data);
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
            endereco: {
                prepare: function (index) {
                    contatoService
                        .prepareEndereco($scope.state.item.Enderecos.filter(a => a.Deleted == false)[index])
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    var endereco = $scope.state.item.Enderecos.filter(a => a.Deleted == false);
                                    endereco[index] = response.Data;
                                    endereco.concat($scope.state.item.Enderecos.filter(a => a.Deleted == true));
                                    $scope.state.item.Enderecos = endereco;
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
                prepareNew: function () {
                    contatoService
                        .prepareNewEndereco($scope.state.item)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item = response.Data;
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });

                },
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;

            $scope.state.vazio = false;
            contatoService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.save = function () {
            $scope.state.salvando = true;

            //adicionar para resolver problema na sicronizaçao
            if (!angular.isUndefined($scope.state.item.Vendedor)
                && $scope.state.item.Vendedor != null
                && !angular.isUndefined($scope.state.item.Vendedor.Filial)
                && $scope.state.item.Vendedor.Filial != null
                && !angular.isUndefined($scope.state.item.Vendedor.Filial.Empresa)
                && $scope.state.item.Vendedor.Filial.Empresa != null) {
                $scope.state.item.Empresa = $scope.state.item.Vendedor.Filial.Empresa;
            }
            contatoService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ title: $scope.Title, text: response.Message });
                        } else {
                            $scope.state.item = response.Data;
                            $scope.historyBack();
                        }
                        $scope.state.salvando = false;
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    });
        };
        $scope.delete = function () {
            $scope.state.salvando = true;
            contatoService
                .delete($scope.state.item.ID)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ title: $scope.Title, text: response.Message });
                        } else {
                            $scope.state.item = response.Data;
                            $scope.historyBack();
                        }
                        $scope.state.salvando = false;
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    });
        };

        $scope.refresh = function () {
            $scope.get();
            $scope.auxiliar.estado.getAll();
            $('[ng-model$="state.item.Nome"]').focus();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();